unit TSR;

interface

 type tproc = procedure;

 var vproc : tproc;
     oldintprog : procedure;
     ident_tsr : string; {identifikan etzec programu}
     is_there : boolean;

 procedure zavadec_tsr (intno : byte; newintcode : tproc;
                        put_in,throw_out : boolean);

implementation

 {$M $800,0,0}

 uses dos,crt;

 {$F+}

 type strptr = ^string;

 var id_process : word;
     my_id : word; {identifikace mho procesu na INT 2Fh}
     oldint2Fh : procedure; {pvodn obsluhy vektor peruen}
     intnumber : byte;
     rg : registers;

 function stringcmp (s1: strptr; s2: strptr): boolean;

  var i,max : integer;

 begin
  max := length (s1^);
  if length (s2^) > length (s1^) then max := length (s2^);
  for i := 1 to max do
   begin
    if s1^[i] <> s2^[i] then
     begin
      stringcmp := false; {etzce jsou rzn}
      exit;
     end;
   end;
  stringcmp := true; {etzce se shoduj}
 end;

 function uninstall : boolean; forward;

 procedure newintprog; interrupt;

 begin vproc; end;

 procedure new2Fh (flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp : word); interrupt;

 begin
  if (ax and $FF00) = my_id then {je to pro mn}
   begin
    case (ax and $00FF) of {vyber slo funkce}
     $00: begin
           ax := ax or $00FF; {kontrola ptomnosti}
           es := seg (ident_tsr); bx := ofs (ident_tsr);
          end;
     $FF: begin
           if (uninstall = false) then ax := $F0;
          end;
    end;
   end
  else
   asm
    mov ax,word ptr oldint2Fh;
    mov word ptr cs:[@off],ax;
    mov ax,word ptr oldint2Fh + 2;
    mov word ptr cs:[@seg],ax;
    pop bp; pop es; pop ds; pop di; pop si; pop dx; pop cx; pop bx; pop ax;
    jmp dword ptr cs:[@off]; {sko na starou obsluhu INT 2Fh}
    @off:
     dw $0000
    @seg:
     dw $0000
   end;
 end;

 function uninstall : boolean;

  var r : registers;
      int2F,intnew : pointer;

 begin
  getintvec (intnumber,intnew);
  getintvec ($2F,int2F);
  if (intnew = addr (newintprog)) and (int2F = addr (new2Fh)) then
   begin
    setintvec (intnumber,addr (oldintprog));
    setintvec ($2F,addr (oldint2Fh));
    r.ah := $49; r.es := prefixseg; intr ($21,r);
    uninstall := true; {program odinstalovn}
   end
  else
   uninstall := false; {nelze odinstalovat}
 end;

 {$F-}

 procedure setusertsr;

 begin
  getintvec (intnumber,@oldintprog);
  setintvec (intnumber,addr (newintprog) );
  getintvec ($2F,@oldint2Fh);
  setintvec ($2F,addr (new2Fh));
  rg.ah := $49; {uvolnm pamt prosted - environmentu}
  rg.es := mem [prefixseg:$2C]; intr ($21,rg);
 end;

 procedure zavadec_tsr (intno : byte; newintcode : tproc;
                        put_in,throw_out: boolean);

 begin
  if ident_tsr = '' then ident_tsr := 'TSR';
  intnumber := intno; vproc := newintcode;
  id_process := $FF; my_id := 0;
  while (id_process > $7F) do {hledm kopii mezi 7Fh - FFh}
   begin
    rg.ah := id_process; rg.al := 0;
    intr ($2F,rg); {Je v pamti mj program s my_id = id_process ?}
    if rg.al = $FF then {Je v pamti => porovnej ident. etzec}
     begin
      if (stringcmp (addr (ident_tsr),ptr (rg.es,rg.bx))) then
       begin {ident. etzec je shodn}
        is_there := true;
        if throw_out then
         begin
          rg.ah := id_process; rg.al := $FF; intr ($2F,rg); {odinstaluj program}
          if rg.ax = $F0 then {nelze odinstalovat}
           begin
            writeLn ('Program nelze odinstalovat z pamti.'); halt (0);
           end
          else
           begin writeLn ('Program odinstalovn z pamti.'); halt (0) end;
         end;
       end;
     end
    else
     if (my_id = 0) and (rg.al = 0) then my_id := id_process shl 8;
    dec (id_process);
   end;
  if (not is_there) and (put_in) then
   if (my_id <> 0) then {kopie nenalezena => instaluj}
    begin
     setusertsr; writeln ('Program instalovn.'); keep (0);
    end
   else
    begin
     writeln ('Program nelze instalovat, pln obsazen INT 2Fh.');
     writeLn ('Nen k dispozici dn ID slo pro program.');
    end;
 end;

begin
 is_there := false;
end.